--------------------------------------------------------------------------
--  DLX PROCESSOR MODEL SUITE
--  Copyright (C) 1995, Martin Gumm
--  University of Stuttgart / Department of Computer Science / IPVR-ISE
--------------------------------------------------------------------------
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 1, or (at your option)
--  any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--------------------------------------------------------------------------
--  Last revision date : November 15 1995
--------------------------------------------------------------------------

--------------------------------------------------------------------------
--  *** SYNOPSYS synthesizable code (ver. 3.2.a) ***
--------------------------------------------------------------------------

--------------------------------------------------------------------------
--  Configuration for the DLX 
--  
--  (file controller_config1.vhd)
--------------------------------------------------------------------------

configuration controller_config1 OF controller IS

  for dataflow

    for state_machine : fsm
      USE ENTITY WORK.fsm(moore_2)
	GENERIC MAP (tpd_fsm => 10 ns,
		     DEBUG => true);
    end for; --state_machine

    for decode_1 : ir_decode_1
      USE ENTITY WORK.ir_decode_1(behaviour)
	GENERIC MAP (tpd_dec => 2 ns);
    end for; --decode_1

    for decode_2 : ir_decode_2
      USE ENTITY WORK.ir_decode_2(behaviour)
	GENERIC MAP (tpd_dec => 2 ns);
    end for; --decode_2
    
    for decode_3 : ir_decode_3
      USE ENTITY WORK.ir_decode_3(behaviour)
	GENERIC MAP (tpd_dec => 2 ns);
    end for; --decode_3
    
  end for; --dataflow
  
end controller_config1;
