--------------------------------------------------------------------------
--  DLX PROCESSOR MODEL SUITE
--  Copyright (C) 1995, Martin Gumm
--  University of Stuttgart / Department of Computer Science / IPVR-ISE
--------------------------------------------------------------------------
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 1, or (at your option)
--  any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--------------------------------------------------------------------------
--  Last revision date : November 15 1995
--------------------------------------------------------------------------

--------------------------------------------------------------------------
--  *** SYNOPSYS synthesizable code (ver. 3.2.a) ***
--------------------------------------------------------------------------

--------------------------------------------------------------------------
--  Entity declaration for the register file (32 32-bit-reg.)
--  one input, two outputs 
--
--  (file reg_file.vhd)
--------------------------------------------------------------------------

--------------------------------------------------------------------------
--  write_en : low active
--------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

use WORK.dlx_types.all;

entity reg_file is
  generic (tpd_in, tac : Time);
  port (addr_out1 : in  dlx_reg_addr;
  	q1        : out dlx_word;
	addr_out2 : in  dlx_reg_addr;
	q2        : out dlx_word;
	addr_in   : in  dlx_reg_addr;
	d         : in  dlx_word;
	write_en  : in  std_logic);
end reg_file;



