--------------------------------------------------------------------------
--  DLX PROCESSOR MODEL SUITE
--  Copyright (C) 1995, Martin Gumm
--  University of Stuttgart / Department of Computer Science / IPVR-ISE
--------------------------------------------------------------------------
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 1, or (at your option)
--  any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--------------------------------------------------------------------------
--  Last revision date : November 15 1995
--------------------------------------------------------------------------

--------------------------------------------------------------------------
--  *** SYNOPSYS synthesizable code (ver. 3.2.a) ***
--------------------------------------------------------------------------
--  
--  (file system.vhd)
--------------------------------------------------------------------------

-------------------------------------------------------------------------
-- new address space for dlx_bench
--
-- 0000_0000 - 0000_FFFF : system rom (64K)
-- 0001_0000 - 0FFF_FFFF : off-board system rom extension (not instantiated) 
-- 1000_0000 - 1000_FFFF : system ram (64K)
-- 1001_0000 - 6FFF_FFFF : off-board system ram extension (not instantiated)
-- 7000_0000 - 7000_000B : 3 32-bit timer register
-- 7000_000C - 7FFF_FFFF : additional IO address space (not instantiated)
-- 8000_0000 - 8000_FFFF : user rom (64K)
-- 8001_0000 - 8FFF_FFEF : off-board system rom extension (not instantiated)
-- 9000_0000 - 9000_FFFF : system ram (64K)
-- 9001_0000 - FFFF_FFFF : off-board system ram extension (not instantiated)
--------------------------------------------------------------------------

library IEEE;
USE IEEE.std_logic_1164.ALL;

library DLX_BENCH;
USE DLX_BENCH.dlx_b_components.all;

USE WORK.dlx_types.all;

entity system is
end system;

