--------------------------------------------------------------------
-- VLSI Design Course / University of Stuttgart
--------------------------------------------------------------------
-- Designers : 
-- Group No. : 
--------------------------------------------------------------------
-- Design Unit Name : rs_ff_test_cfg2
-- Purpose : configuration for the RS flipflop and its test bench
-- 
-- File Name : rs_ff_test-config2.vhd
--------------------------------------------------------------------
-- Simulator : SYNOPSYS VHDL System Simulator (VSS) Version 3.2.
--------------------------------------------------------------------
--  Date	   | Changes
--  01 October 95  | original version
--
--------------------------------------------------------------------

CONFIGURATION rs_ff_test_cfg2 OF rs_ff_test IS
  --
  -- Choose an architecture for the test-bench entity "clockgen_test"
  -- The name of the chosen architecture is "bench"
  --
  FOR bench
    --
    -- Choose an entity for the component declared in the testbench-
    -- architecture (the chosen entity is "rs_ff").
    -- Choose an architecture for the instantiated entity (the chosen
    -- architecture is "dataflow").
    FOR ff1 : rs_ff
      USE ENTITY WORK.rs_ff(structural)
        --
        -- Assign values for the generic parameters of the entity "clockgen"
        -- (this defines the generated clock signal)
        --
        GENERIC MAP (tpd_snor => 1 ns, tpd_rnor => 1 ns);

	for structural

	  for snor : TEACH_LOGIC_LIB.logic_components.nor2
	    use entity TEACH_LOGIC_LIB.nor2(dataflow)
	      generic map (tpd_nor => tpd_snor);
	  end for; -- snor

	  for rnor : TEACH_LOGIC_LIB.logic_components.nor2
	    use entity TEACH_LOGIC_LIB.nor2(dataflow)
	      generic map (tpd_nor => tpd_rnor);
          end for; -- rnor
	end for ; -- structural
	
    END FOR; -- ff1
    
  END FOR; -- bench
  
END rs_ff_test_cfg2;
