--------------------------------------------------------------------
-- VLSI Design Course / University of Stuttgart
--------------------------------------------------------------------
-- Sample library (teach_logic_lib)
-- Package declaration for the use of the library components
--------------------------------------------------------------------
-- Simulator : SYNOPSYS VHDL System Simulator (VSS) Version 3.2.
--------------------------------------------------------------------
--  Date	   | Changes
--  01 October 95  | original version
--		
--------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
  
PACKAGE logic_components IS

component resetgen
  port (reset_out : out std_logic);
end component;

component delay
  port (a : in std_logic;
        y : out std_logic);
end component;

component inv
  port (a : in std_logic;
        y : out std_logic);
end component;

component buf
  port (a : in std_logic;
        y : out std_logic);
end component;

component and2
  port (a, b : in std_logic;
        y : out std_logic);
end component;

component nand2
  port (a, b : in std_logic;
        y : out std_logic);
end component;

component or2
  port (a, b : in std_logic;
        y : out std_logic);
end component;

component nor2
  port (a, b : in std_logic;
        y : out std_logic);
end component;

component  mux21
  port (IN0, IN1 : in std_logic;
        SEL : std_logic;
        Y : out std_logic);
end component;

END logic_components;

